clear all


U_ref = 0.3;
T_ud = 30;
T_z = 50;
time = 10;
h = 0.1;
radius_acceptance = 1;
t = 2;


DP = 0;
wptk = 1;

%pattern generator
xstart = 10;
ystart = 10;
xslutt = 60;
yslutt = 20;
antallinjer = 4;
avstand = 6;

wpt.x(1) = xstart;
wpt.y(1) = ystart;
wpt.x(2) = xslutt;
wpt.y(2) = yslutt;


wptn = 2*antallinjer;
for i=1:wptn
    wpt.z(i) = 10;
end

dydx = (yslutt-ystart)/(xslutt-xstart);

dx = sqrt((avstand^2)*(dydx)^2);
if dydx > 0
    dx = -dx;
end

dy = sqrt((avstand)^2 - (dx)^2);


for i=3:2:wptn-1     
    wpt.x(i) = dx + wpt.x(i-1);
    wpt.y(i) = dy + wpt.y(i-1);
    wpt.x(i+1) = dx + wpt.x(i-2);
    wpt.y(i+1) = dy + wpt.y(i-2);
end

wpt.z = [10 15 15 20 20 30 30 20];

%initial parameters
parameters_m1.signals.values = [92.7555   -2.8801    7.0086   -0.0402   -6.0783    2.9824   -2.8067   56.9835   -6.7872 1.4581    2.3244    3.6558    7.1285   -6.7173   70.8922    2.2241   -4.0484    0.3005 0.8000    0.3339    4.1734    4.0562   -0.4449   -0.2257   -3.9437    4.1888   -6.6508  0.1193    8.4155    0.4094    3.0623    3.6980    0.3499   -0.2040    0.1829   61.0325];
parameters_dl1.signals.values = [-0.2982   -0.2360    0.0596   -0.1029   -1.0301    0.3190    0.8247   -0.1440    0.2206 0.3079    0.0518    0.1997   -0.5140   -0.2226   -0.2234    0.0333   -0.1945   -0.0055  -0.1588   -0.3089    0.0538   -0.0190   -0.0600   -0.0279    1.3373   -0.1118    0.0869 0.0554   -0.1040    0.0719   -0.0100    0.0539   -0.5879   -0.0253    0.0179    1.6324];

parameters_dq1.signals.values = [-0.2184   -0.0093   -0.0221   -0.0009   -0.0277    0.2138];
parameters_g1.signals.values = [2.3614   -0.8597   -0.9915   -0.0228];
parameters_k1.signals.values = [13.2308   -7.6913   -5.4606   -0.0791   -0.1677   -0.7482];
parameters_e1.signals.values = [-0.3596    5.1542   -0.3671   -0.1482    0.2084    2.4522];







%Gains

Delta = 0.1;

lambda = diag([10 10 10 10 10 10]);

K_d = diag([20 20 20 1 1 10]);
K_p = diag([100 100 50 50 50 100]);



%Vessel model
environment = [100 -50 0 0 0 0]';
vesselpos = zeros(6,1);

W = 405;
Bouy = 400;
r_g = [0 0  0.3]';
r_b = [0 0 0]';
m = W;

L = 1.44;
B = 0.82;
H = 0.8;
rho = m/H*B*L;

Ix = (1/12)*rho*L*H*B*(B^2 + H^2);
Iy = (1/12)*rho*L*H*B*(L^2 + H^2);
Iz = (1/12)*rho*L*H*B*(B^2 + L^2);
I_c = diag([Ix Iy Iz]);

I_0 = I_c - m*(r_g*r_g' - r_g'*r_g*eye(3));


M = [m          0           0           0           m*r_g(3)        -m*r_g(2)
     0          m           0           -m*r_g(3)   0               m*r_g(1)
     0          0           m           m*r_g(2)    -m*r_g(1)       0
     0          -m*r_g(3)   m*r_g(2)    I_0(1,1)    I_0(1,2)         I_0(1,3)
     m*r_g(3)   0           -m*r_g(1)   I_0(2,1)    I_0(2,2)         I_0(2,3)
     -m*r_g(2)  m*r_g(1)    0           I_0(3,1)    I_0(3,2)         I_0(3,3)];

invM = inv(M);


K_cdrag = diag([-5 -5 -5 0 0 0]);

lx1 = 0.3;
lz1 = -0.03;
lx2 = 0.1;
ly2 = -0.2;
lx3 = lx2;
ly3 = -ly2;
lx4 = -0.5;
ly4 = -0.2;
lz4 = 0.42;
lx5 = lx4;
ly5 = -ly4;
lz5 = lz4;

T6 = [ 0             0               cosd(-10)                       cosd(10) 
      1             0               sind(-10)                       sind(10)
      0             2               0                               0
      -lz1          0               -lz4*sind(-10)                  -lz5*sind(10)
      0             -lx2            lz4*cosd(-10)                   lz5*cosd(10)
      lx1           0               lx4*sind(-10)-ly4*cosd(-10)     lx5*sind(10)-ly5*cosd(10)

    ];
T4 = [ 0             0               cosd(-10)                       cosd(10) 
      1             0               sind(-10)                       sind(10)
      0             2               0                               0
      lx1           0               lx4*sind(-10)-ly4*cosd(-10)     lx5*sind(10)-ly5*cosd(10)

    ];



Tinv = inv(T4);

